import type { Article } from "../domain/articleEntity";
import * as actionTypes from "./articleActionTypes";
import { dispatchStatus } from "../../store/index";

const setArticleAction = (article: Article, articlesList: Array<Article>) => (dispatch: any) => {
  if (!articlesList.includes(article)) {
    const updatedList = articlesList.concat([article]);
    dispatch({ type: actionTypes.SET_ARTICLE, article, updatedList });
  }
}

const getArticleAction = (id: string, articles: Array<Article>) => (dispatch: any) => {
  const filteredArray = articles.filter((e) => e.id == id);
  if (filteredArray.length > 0) {
    const article = filteredArray[0];
    dispatchStatus(actionTypes.GET_ARTICLE, ".success", article)(dispatch);
    return article;
  }

  const reason = 'Article not in the store';
  dispatchStatus(actionTypes.GET_ARTICLE, ".failure", reason)(dispatch);
  return null;
};

export { setArticleAction, getArticleAction };
